from apm import *

s = 'http://byu.apmonitor.com'
a = 'optimization'

apm(s,a,'clear all')
apm_load(s,a,'periodic_opt.apm')
csv_load(s,a,'time.csv')

apm_option(s,a,'nlc.imode',6)
apm_option(s,a,'nlc.reqctrlmode',3)
apm_option(s,a,'nlc.solver',1)
apm_option(s,a,'nlc.cv_type',1)
apm_option(s,a,'nlc.max_iter',300)
apm_option(s,a,'nlc.nodes',4)

apm_info(s,a,'FV','p')
apm_option(s,a,'p.status',1)
apm_info(s,a,'SV','stored')
apm_info(s,a,'SV','recovery')
apm_info(s,a,'SV','vx')
apm_info(s,a,'SV','vy')
output = apm(s,a,'solve')
print output

y = apm_sol(s,a)

apm_web_var(s,a)

import matplotlib.pyplot as plt

plt.figure(1)
plt.subplot(411)
plt.plot(y['time'],y['stored'],'r-',label='storing')
plt.plot(y['time'],y['recovery'],'b-.',label='recovering')
plt.legend()

plt.subplot(412)
plt.plot(y['time'],y['d'],'k-',label='Demand')
plt.plot(y['time'],y['p'],'r--',label='Production')
plt.legend()

plt.subplot(413)
plt.plot(y['time'],y['s'],'g-',label='Storage')
plt.legend()

plt.subplot(414)
plt.plot(y['time'],y['vx'],'g-',label='vx')
plt.plot(y['time'],y['vy'],'r--',label='vy')
plt.legend()
plt.xlabel('Time (hr)')
plt.savefig('optimization.png')
plt.show()
